
alias legolib {
  %_.pveng = C:\programing\newpov\bin\pvengine.exe

  if (!%lego.dir) %lego.dir = $lower($scriptdir)
  dialog -ma legolib legolib
  did -c legolib 3 1
  if (!$did(legolib,3).text) {
    did -i legolib 3 1 %lego.dir
    did -c legolib 3 1
  }
  else %lego.dir = $did(legolib,3).seltext
}
alias object_export {
  var %d = %_.pveng
  run %d /RENDER $1
}


on *:dialog:legolib:dclick:4: render_item
on *:dialog:legolib:edit:3: %lego.dir = $did(legolib,3).text
on *:dialog:legolib:sclick:13: { _item_search | haltdef }
on *:dialog:legolib:sclick:115: render_item
on *:dialog:legolib:sclick:114: _path_


alias render_item {
  var %dir = $scriptdir

  var itemfile = legolib.pov 
  var %item = $did(legolib,4).seltext
  var  %r = $gettok(%item,1,40)
  var %rend_as = $+(%dir,%r,.pov)

  if (%item) e %item
  if (%item) e %rend_as
  if ($exists(%rend_as)) remove %rend_as
  copy $+(%dir,povtemp.txt) %rend_as

  write %rend_as object $chr(123) %r $+ (red_tex) rotate <0,0,0> scale 2 translate <0,0,0> $chr(125)
  object_export %rend_as
  ; run wordpad %rend_as
}

alias lgwinpos {
  var %x = 350
  if (%x < 0) %x = 0
  return %x 500 640 480
}
dialog legolib {
  option pixels
  title "Lego Catalog"
  size $lgwinpos
  icon eye.ico,-1
  tab "Lego", 101, 0 0 640 480
  tab "Build", 102
  tab "Vars", 300

  edit "Legos",1,12 35 160 24, tab 101
  edit "*.pov,*.inc",2,180 35 160 24, tab 101
  combo 3,180 65 250 24,edit, tab 101

  combo 4, 12 95 318 373, size, tab 101
  button "Load Legos",13,92 65 80 24, tab 101, ok
  button "Rend Item",115,12 65 80 24, tab 101
  button "New Path",114,348 35 80 24, tab 101
}

alias _item_search {
  var %f = $+($scriptdir,legolib.txt), %dir = $scriptdir, %r
  %lego.dir = $did(legolib,3)
  var %i = 0, %n = $lines(%f)
  did -r legolib 4

  if ($fopen(legofile)) fclose legofile
  .fopen legofile %f

  while (%i < %n) {
    inc %i
    %r = $fread(legofile)
    ;    e %r
    if (%r) did -a legolib 4 %r
  }
  fclose legofile
  e %i Legos Items
}
